#include "q3la.h"

p2p_t::p2p_t()
{
	init();
}

void p2p_t::init()
{
	for (int i = 0; i < MAX_WEAPONS; i++) {
		kills[i]	= 0;
		killed[i]	= 0;
	}
	next				= 0;
	name[0]				= 0;
	htmlname_fun[0]		= 0;
	htmlname_nofun[0]	= 0;
}

p2p_t::~p2p_t()
{
	if (next != 0) {
		delete next;
	}
	next = 0;
}

p2p_t* p2p_t::build_next()
{
	next = new p2p_t;
	return next;
}

p2p_t p2p_t::operator= (p2p_t &other)
{
	for (int i = 0; i < MAX_WEAPONS; i++) {
		kills[i] = other.kills[i];
		killed[i] = other.killed[i];
	}
	strcpy (name, other.name);
	strcpy (htmlname_fun, other.htmlname_fun);
	strcpy (htmlname_nofun, other.htmlname_nofun);
	next = other.next;
	return other;
}

void p2p_t::set_name (char* in_name) {
	if (strlen (in_name) > MAX_NAME_LEN) {
		error::msg_and_exit ("p2p_t::set_name - overflow");
	}
	if (strcmp (name, in_name) != 0) {
		strcpy (name, in_name);
		set_htmlnames (in_name);
	}
}

void p2p_t::set_htmlnames (char* in_name) {
	strcpy (htmlname_fun, diverse::funname_to_html(in_name));
	strcpy (htmlname_nofun, diverse::funname_to_ascii(in_name));
}

char* p2p_t::get_name () {
	return name;
}

char* p2p_t::get_htmlname (bool no_funnames) {
	if (no_funnames) {
		return htmlname_nofun;
	} else {
		return htmlname_fun;
	}
}

unsigned int p2p_t::get_kills(int weapon)
{
	return kills[weapon];
}

unsigned int p2p_t::get_killed(int weapon)
{
	return killed[weapon];
}

unsigned int p2p_t::get_kills()
{
	return kills[0];
}


unsigned int p2p_t::get_killed()
{
	return killed[0];
}