#include "q3la.h"

player_t::player_t()
{
	init();
}

void player_t::init()
{
	for (int i = 0; i < MAX_WEAPONS; i++) {
		kills[i]	= 0;
		killed[i]	= 0;
		suicides[i]	= 0;
		teamkills[i]	= 0;
	}
	iterator			= 0;
	game_count			= 0;
	ping_count			= 0;
	ping_sum			= 0;
	deaths				= 0;
	mkiol				= 0;
	mkiol_time			= 0;
	next				= 0;
	playtime			= 0;
	ratio				= 0;
	eff					= 0;
	skill				= 0;
	strcpy (name, "ERROR_NO_INIT");
	htmlname_fun[0]		= 0;
	htmlname_nofun[0]	= 0;
	botskill			= -1;
	team				= -1;
	teams[0]			= 0;
	listed				= false;
	// items
	item_pickups = 0;
	// health & armor
	item_health = 0;
	item_health_small = 0;
	item_health_large = 0;
	item_health_mega = 0;
	item_armor_shard = 0;
	item_armor_combat = 0;
	item_armor_body = 0;
	// diverse
	item_enviro = 0;
	item_flight = 0;
	item_haste = 0;
	item_invis = 0;
	item_quad = 0;
	item_regen = 0;
	holdable_medkit = 0;
	holdable_teleporter = 0;
	team_CTF_blueflag = 0;
	team_CTF_redflag = 0;
	// ammo
	ammo_bfg = 0;
	ammo_bullets = 0;
	ammo_cells = 0;
	ammo_grenades = 0;
	ammo_lightning = 0;
	ammo_rockets = 0;
	ammo_shells = 0;
	ammo_slugs = 0;
	// weapons
	weapon_bfg = 0;
	weapon_grenadelauncher = 0;
	weapon_lightning = 0;
	weapon_machinegun = 0;
	weapon_plasmagun = 0;
	weapon_railgun = 0;
	weapon_rocketlauncher = 0;
	weapon_shotgun = 0;
	weapon_chaingun = 0;
	weapon_nailgun = 0;
	weapon_prox_launcher = 0;
}

player_t::~player_t()
{
	if (next != 0) {
		delete next;
	}
	next = 0;
}

player_t* player_t::build_next()
{
	next = new player_t;
	return next;
}

player_t player_t::operator= (player_t &other)
{
	for (int i = 0; i < MAX_WEAPONS; i++) {
		kills[i] = other.kills[i];
		killed[i] = other.killed[i];
		suicides[i] = other.suicides[i];
		teamkills[i] = other.teamkills[i];
	}
	iterator = other.iterator;
	game_count = other.game_count;
	ping_count = other.ping_count;
	ping_sum = other.ping_sum;
	botskill = other.botskill;
	team = other.team;
	strcpy (teams, other.teams);
	deaths = other.deaths;
	mkiol = other.mkiol;
	mkiol_time = other.mkiol_time;
	ratio = other.ratio;
	eff = other.eff;
	skill = other.skill;
	strcpy (name, other.name);
	strcpy (htmlname_fun, other.htmlname_fun);
	strcpy (htmlname_nofun, other.htmlname_nofun);
	next = other.next;
	playtime = other.playtime;
	// items
	item_pickups = other.item_pickups;
	// armor & health
	item_health_small = other.item_health_small;
	item_health_large = other.item_health_large;
	item_health_mega = other.item_health_mega;
	item_armor_shard = other.item_armor_shard;
	item_armor_combat = other.item_armor_combat;
	item_armor_body = other.item_armor_body;
	// diverse 
	item_enviro = other.item_enviro;
	item_flight = other.item_flight;
	item_haste = other.item_haste;
	item_invis = other.item_invis;
	item_quad = other.item_quad;
	item_regen = other.item_regen;
	holdable_medkit = other.holdable_medkit;
	holdable_teleporter = other.holdable_teleporter;
	team_CTF_blueflag = other.team_CTF_blueflag;
	team_CTF_redflag = other.team_CTF_redflag;
	// ammo
	ammo_bullets = other.ammo_bullets;
	ammo_shells = other.ammo_shells;
	ammo_grenades = other.ammo_grenades;
	ammo_rockets = other.ammo_rockets;
	ammo_slugs = other.ammo_slugs;
	ammo_cells = other.ammo_cells;
	// weapons
	weapon_shotgun = other.weapon_shotgun;
	weapon_grenadelauncher = other.weapon_grenadelauncher;
	weapon_rocketlauncher = other.weapon_rocketlauncher;
	weapon_lightning = other.weapon_lightning;
	weapon_railgun = other.weapon_railgun;
	weapon_plasmagun = other.weapon_plasmagun;
	weapon_chaingun = other.weapon_chaingun;
	weapon_nailgun = other.weapon_nailgun;
	weapon_prox_launcher = other.weapon_prox_launcher;
	return other;
}

void player_t::set_name (char* in_name) {
	if (in_name[0] == 0) {
		strcpy (name, "Q3LA_ERROR_EMPTY_NAME");
		set_htmlnames ("Q3LA_ERROR_EMPTY_NAME");
		return;
	}
	if (strlen (in_name) > MAX_NAME_LEN) {
		error::msg_and_exit ("player_t::set_name - overflow");
	}
	if (strcmp (name, in_name) != 0) {
		strcpy (name, in_name);
		set_htmlnames (in_name);
	}
}

void player_t::set_htmlnames (char* in_name) {
	strcpy (htmlname_fun, diverse::funname_to_html(in_name));
	strcpy (htmlname_nofun, diverse::funname_to_ascii(in_name));
}

char* player_t::get_name () {
	return name;
}

char* player_t::get_htmlname (bool no_funnames) {
	if (no_funnames) {
		return htmlname_nofun;
	} else {
		return htmlname_fun;
	}
}

unsigned int player_t::get_kills(int weapon)
{
	return kills[weapon];
}

unsigned int player_t::get_teamkills(int weapon)
{
	return teamkills[weapon];
}

unsigned int player_t::get_killed(int weapon)
{
	return killed[weapon];
}

unsigned int player_t::get_suicides(int weapon)
{
	return suicides[weapon];
}

unsigned int player_t::get_kills()
{
	return kills[0];
}

unsigned int player_t::get_teamkills()
{
	return teamkills[0];
}

unsigned int player_t::get_killed()
{
	return killed[0];
}

unsigned int player_t::get_suicides()
{
	return suicides[0];
}

unsigned int player_t::get_deaths()
{
	return deaths;
}

int player_t::get_frags()
{
	return (get_kills() - deaths - get_suicides());
}

double player_t::get_skill()
{
	if (skill == 0) {
		skill = (double) get_kills() / (double) (get_killed() + deaths + get_suicides() + 1);
	}
	return skill;
}

double player_t::get_eff()
{
	if (eff == 0) {
		if (get_kills() + (get_killed() + deaths + get_suicides()) == 0) {
			eff = 0;
		} else {
			eff = 100.0 * (double) get_kills() / (double) (get_kills() + (get_killed() + deaths + get_suicides()));
		}
	}
	return eff;
}

double player_t::get_ratio()
{
	if (ratio == 0) {
		if (playtime == 0) { // prevent divide by zero
			ratio = -9999; // error, playtime == 0!
		} else {
			ratio = (double) (get_frags() * 60.0 / playtime) - (double) ((get_killed() + deaths + get_suicides()) * 60.0 / playtime);
		}
	}
	return ratio;
}

void player_t::add_ping(int ping)
{
	ping_count++;
	ping_sum += ping;
}
