#include "q3la.h"

resultdata_total::resultdata_total(configdata* in_config)
{
	config = in_config;
}

resultdata_total::~resultdata_total()
{
}

int resultdata_total::add_results(resultdata *result)
{
	player_t* temp_player;
	p2p_t* temp_p2p;
	for (int i = 0; i < result->get_player_count(); i++) {
		temp_player = get_player (result->get_player(i)->get_name());
		for (int j = 0; j < MAX_WEAPONS; j++) {
			temp_player->kills[j] += result->get_player(i)->kills[j];
			temp_player->killed[j] += result->get_player(i)->killed[j];
			temp_player->suicides[j] += result->get_player(i)->suicides[j];
		}
		for (int k = 0; k < result->get_player_count(); k++) {
			if (k == i) continue;
			temp_p2p = get_p2p (temp_player, result->get_player(k)->get_name());
			for (int l = 0; l < MAX_WEAPONS; l++) {
				temp_p2p->kills[l] += result->get_kills(i, k, l);
				temp_p2p->killed[l] += result->get_kills(k, i, l);
			}
		}
		temp_player->botskill = result->get_player(i)->botskill; // why is this necessary???
		temp_player->game_count++;
		temp_player->ping_count += result->get_player(i)->ping_count;
		temp_player->ping_sum += result->get_player(i)->ping_sum;
		temp_player->deaths += result->get_player(i)->deaths;
		temp_player->playtime += result->get_player(i)->playtime;
		temp_player->mkiol += result->get_player(i)->mkiol;
		temp_player->mkiol_time += result->get_player(i)->mkiol_time;
	}
	return 0;
}

player_t* resultdata_total::get_player(char* name)
{
    player_t* temp_player;
    char nofun[MAX_NOFUN_LEN];
    strcpy (nofun, diverse::funname_to_ascii(name));
	config->get_alias (nofun);

    // Check if player exists

    for (int i = 0; i < MAX_ALIAS; i++) {
        if (config->alias[i][0] == 0) break;
        temp_player = search_player (config->alias[i]);
        if (temp_player != 0) break;
    }

    // if player doesn't exist yet, create 

	if (temp_player == 0) {
		temp_player = add_player (name);
	}

	// Return pointer to existing or newly created player

	return temp_player;
}

player_t* resultdata_total::search_player(char* name)
{
	player_t* temp_player = first_player.next;

	// Check if player exists

	while (temp_player != 0) {
		char name1[256];
		strcpy (name1, diverse::funname_to_ascii(temp_player->get_name()));
		char name2[256];
		strcpy (name2, name);
		_strlwr (name1);
		_strlwr (name2);
		if (strcmp (name1, name2) == 0) {
			break;
		}
		temp_player = temp_player->next;
	}

	return temp_player;
}

p2p_t* resultdata_total::get_p2p(player_t* player, char *name)
{
	p2p_t* temp_p2p = player->first_p2p.next;

	// Check if p2p exists

	while (temp_p2p != 0) {
		char name1[256];
		strcpy (name1, diverse::funname_to_ascii(temp_p2p->get_name()));
		char name2[256];
		strcpy (name2, diverse::funname_to_ascii(name));
		_strlwr (name1);
		_strlwr (name2);
		if (strcmp (name1, name2) == 0) {
			break;
		}
		temp_p2p = temp_p2p->next;
	}

	// if p2p doesn't exist yet, create 

	if (temp_p2p == 0) {
		temp_p2p = add_p2p (player, name);
	}

	// Return pointer to existing or newly created p2p

	return temp_p2p;
}

player_t* resultdata_total::add_player(char *name)
{
	// Go to last player, add player and return pointer to new player
	static int iterator = 0;

	player_t* temp_player = &first_player;
	while (temp_player->next != 0) {
		temp_player = temp_player->next;
	}
	temp_player->build_next();
	temp_player = temp_player->next;
	temp_player->set_name(name);
	temp_player->iterator = ++iterator;
	return temp_player;
}

p2p_t* resultdata_total::add_p2p(player_t* player, char* name)
{
	// Go to last p2p, add p2p and return pointer to new p2p

	p2p_t* temp_p2p = &(player->first_p2p);
	while (temp_p2p->next != 0) {
		temp_p2p = temp_p2p->next;
	}
	temp_p2p->build_next();
	temp_p2p = temp_p2p->next;
	temp_p2p->set_name(name);
	return temp_p2p;
}

int resultdata_total::sort_players(sort_t order)
{
	int p_count = get_player_count();
	int p_num = 0;
	bool swap;
	int swapcount = 0;
	int comparecount = 0;
	s_order = order;
	printf ("\n- Sorting all players        ");
	player_t* previous1 = &first_player;
	player_t* player1 = previous1->next;
	for (int i = 0; i < p_count-1; i++) {
		p_num++;
		printf ("\b\b\b\b\b\b\b(%3i %%)", (100*(p_num))/(p_count)); // progress indication
		player_t* previous2 = player1;
		player_t* player2 = player1->next;
		for (int j = i+1; j < p_count; j++) {
			comparecount++;
			swap = false;
			if ((player1 == 0) || (player2 == 0)) {
				error::msg_and_exit ("resultdata_total::sort_players: error for i=%i, j=%i, p_count=%i", i, j, p_count);
			}
			double double1 = 0;
			double double2 = 0;
			int int1 = 0;
			int int2 = 0;
			char str1[256] = "";
			char str2[256] = "";

			switch (order) { // get compare values
			case so_name:
				strcpy (str1, player1->htmlname_nofun);
				strcpy (str2, player2->htmlname_nofun);
				_strlwr (str1);
				_strlwr (str2);
				break;
			case so_ratio:
				double1 = (double) player1->get_ratio();
				double2 = (double) player2->get_ratio();
				break;
			case so_eff:
				double1 = (double) player1->get_eff();
				double2 = (double) player2->get_eff();
				break;
			case so_skill:
				double1 = (double) player1->get_skill();
				double2 = (double) player2->get_skill();
				break;
			case so_kills:
				int1 = player1->get_kills();
				int2 = player2->get_kills();
				break;
			case so_killed:
				int1 = player1->get_killed();
				int2 = player2->get_killed();
				break;
			case so_team:
				int1 = player1->team;
				int2 = player2->team;
				break;
			case so_frags:
				int1 = player1->get_frags();
				int2 = player2->get_frags();
				break;
			case so_score:
				int1 = player1->get_frags() - player1->get_teamkills();
				int2 = player2->get_frags() - player2->get_teamkills();
				break;
			case so_playtime:
				int1 = player1->playtime;
				int2 = player2->playtime;
				break;
			default:
				error::msg_and_exit ("resultdata_total::sort_players - invalid case");
				break;
			}

			switch (order) { // sort if necessary
			case so_name:
				if (strcmp (str1, str2) > 0) {
					swap = true;
				}
				break;
			case so_ratio:
			case so_eff:
			case so_skill:
				if (double1 < double2) {
					swap = true;
				}
				break;
			case so_kills:
			case so_killed:
			case so_team:
			case so_frags:
			case so_score:
			case so_playtime:
				if (int1 < int2) {
					swap = true;
				}
				break;
			default:
				error::msg_and_exit ("resultdata_total::sort_players - invalid case");
				break;
			}
			if (swap) {
				swapcount++;
//				printf ("\nswapping players %i and %i", i, j); // DEBUG
				swap_next_players (previous1, previous2);
				previous2 = player1;
				player1 = player2;
				player2 = previous2->next;
			} else {
				previous2 = player2;
				player2 = player2->next;
			}
		}
		previous1 = player1;
		player1 = player1->next;
	}
	printf ("\b\b\b\b\b\b\b(100 %%)\n"); // progress indication
//	printf ("\n%i comparisons, %i player swaps\n", comparecount, swapcount); // DEBUG
	return 0;
}

int resultdata_total::sort_p2p(player_t* player, sort_t order)
{
	int p_count = get_p2p_count(player);
	int p_num = 0;
	bool swap;
	int swapcount = 0;
	int comparecount = 0;
	s_order = order;
	p2p_t* previous1 = &(player->first_p2p);
	p2p_t* p2p1 = previous1->next;
	for (int i = 0; i < p_count-1; i++) {
		p_num++;
		p2p_t* previous2 = p2p1;
		p2p_t* p2p2 = p2p1->next;
		for (int j = i+1; j < p_count; j++) {
			comparecount++;
			swap = false;
			if ((p2p1 == 0) || (p2p2 == 0)) {
				error::msg_and_exit ("resultdata_total::sort_p2ps: error for i=%i, j=%i, p_count=%i", i, j, p_count);
			}
			int int1 = 0;
			int int2 = 0;
			char str1[256] = "";
			char str2[256] = "";

			switch (order) { // get compare values
			case so_name:
				strcpy (str1, p2p1->htmlname_nofun);
				strcpy (str2, p2p2->htmlname_nofun);
				_strlwr (str1);
				_strlwr (str2);
				break;
			case so_kills:
				int1 = p2p1->get_kills();
				int2 = p2p2->get_kills();
				break;
			case so_killed:
				int1 = p2p1->get_killed();
				int2 = p2p2->get_killed();
				break;
			default:
				error::msg_and_exit ("resultdata_total::sort_p2ps - invalid case");
				break;
			}

			switch (order) { // sort if necessary
			case so_name:
				if (strcmp (str1, str2) > 0) {
					swap = true;
				}
				break;
			case so_kills:
			case so_killed:
				if (int1 < int2) {
					swap = true;
				}
				break;
			default:
				error::msg_and_exit ("resultdata_total::sort_p2ps - invalid case");
				break;
			}
			if (swap) {
				swapcount++;
				swap_next_p2p (previous1, previous2);
				previous2 = p2p1;
				p2p1 = p2p2;
				p2p2 = previous2->next;
			} else {
				previous2 = p2p2;
				p2p2 = p2p2->next;
			}
		}
		previous1 = p2p1;
		p2p1 = p2p1->next;
	}
	return 0;
}

int resultdata_total::get_player_count()
{
	int count = 0;
	player_t* temp_player = &first_player;
	while (temp_player->next != 0) {
		count++;
		temp_player = temp_player->next;
	}
	return count;
}

int resultdata_total::get_p2p_count(player_t* player)
{
	int count = 0;
	p2p_t* temp_p2p = &(player->first_p2p);
	while (temp_p2p->next != 0) {
		count++;
		temp_p2p = temp_p2p->next;
	}
	return count;
}

void resultdata_total::dump_players() // DEBUG
{
	int count = 0;
	printf ("\n");
	player_t* temp_player = first_player.next;
	while (temp_player != 0) {
		printf ("\n%3i: %s", ++count, temp_player->get_name());
		temp_player = temp_player->next;
	}
}

void resultdata_total::swap_next_players(player_t *previous1, player_t *previous2)
{
	player_t* player1 = previous1->next;
	player_t* player2 = previous2->next;
	player_t* behind1 = player1->next;
	player_t* behind2 = player2->next;
	if (player1 == previous2) {
		previous1->next = player2;
		player2->next = player1;
		player1->next = behind2;
	} else if (behind1 == previous2) {
		previous1->next = player2;
		player2->next = behind1;
		behind1->next = player1;
		player1->next = behind2;
	} else {
		previous1->next = player2;
		player2->next = behind1;
		previous2->next = player1;
		player1->next = behind2;
	}
}

void resultdata_total::swap_next_p2p(p2p_t *previous1, p2p_t *previous2)
{
	p2p_t* p2p1 = previous1->next;
	p2p_t* p2p2 = previous2->next;
	p2p_t* behind1 = p2p1->next;
	p2p_t* behind2 = p2p2->next;
	if (p2p1 == previous2) {
		previous1->next = p2p2;
		p2p2->next = p2p1;
		p2p1->next = behind2;
	} else if (behind1 == previous2) {
		previous1->next = p2p2;
		p2p2->next = behind1;
		behind1->next = p2p1;
		p2p1->next = behind2;
	} else {
		previous1->next = p2p2;
		p2p2->next = behind1;
		previous2->next = p2p1;
		p2p1->next = behind2;
	}
}

